# Copyright (c) 2006, Brian Frank, Andy Frank, and John Sublett.
# Licensed under BSD, see http://www.fandev.org/license.txt for terms.

#
# jonly -- script to run Fan Java runtime in precompiled only mode
#
# @author   Brian Frank
# @creation 6 Sep 06
#

require 'adm/env.rb'

class Jonly < Env

##########################################################################
# Main
##########################################################################

  # main
  def main()
    # check we have at least one args
    if ARGV.size < 2 then
      usage()
      return
    end
    
    cmd = ARGV[0]
    target = ARGV[1]
    if (target == 'all') 
      target = @@all_pods.join(' ')
    end
    
    case cmd
      when 'fan'
        runcmd('fanx.tools.Fan', target)
      when 'fant'
        runcmd('fanx.tools.Fant', target)
      else
        raise "Unknown command: #{cmd}"
    end
    
  end

##########################################################################
# Usage
##########################################################################

  def usage()
    puts "usage:"
    puts "  jonly fan <target>  run fan runtime against target slot"
    puts "  jonly fant <target>  run fan test suite with specified target or all"
  end

##########################################################################
# Runcmd
##########################################################################

  def runcmd(cmd, target)
    # get list of jars
    jars = Dir.glob(@fan_lib_java + "/*.jar")
    cmd = "java -Dfan.usePrecompiledOnly=true -cp " + jars.join(';') + " #{cmd} #{target}"
    ARGV[2..-1].each {|a| cmd = cmd + " " + a }    
    system(cmd)
   end
   
end

# script
Jonly.new.main