# Copyright (c) 2006, Brian Frank, Andy Frank, and John Sublett.
# Licensed under BSD, see http://www.fandev.org/license.txt for terms.

#
# maken -- build the .Net runtime
#
# @author   John Sublett
# @creation 08 Apr 2006
#

require 'adm/env.rb'

class Maken < Env

  # init
  def initialize
    super
    @temp = File.join(@src_nfan , "temp")
  end

  # main
  def main()
    if (ARGV.include?("clean"))
      clean
    elsif (ARGV.include?("cleanexe"))
      clean
      build(false)
    elsif (ARGV.include?("all"))
      clean
      build(true)
    else
      build(false)    
    end
  end
 
  # clean it all up
  def clean
    # todo - handle lib/net too
    puts "maken clean"
    ["nfan", "nfant"].each do |prog|
      f = File.join(@fan_bin, prog + ".exe")
      File.delete(f) unless !File.exists?(f)
      f = File.join(@fan_bin, prog + ".pdb")
      File.delete(f) unless !File.exists?(f)
    end
  end
 
  # build the nfan.exe 
  def build(nboot)
    puts "maken build sys"
    begin
      buildsys      
      #buildtools
      puts "  Build Successful"
    rescue
    end
    #if (nboot)
    #  puts "maken build nboot"
    #  begin
    #    buildnboot
    #    puts "  Build Successful"
    #  rescue
    #  end
    #end
  end
  
  def buildsys
    Dir.chdir(@src_nfan)
    cmd = "csc /nologo /target:library /debug:full /out:#@fan_lib_net/sys.dll /fullpaths"
    cmd += " /recurse:*.cs"
    cmd += " /r:#@fan_lib/net/ICSharpCode.SharpZipLib.dll;#@fan_lib/net/PERWAPI.dll"
    p = open("|" + cmd)
    count = 0
    while ((line = p.gets) != nil)
      print "  " + line
      count += 1
    end
    p.close
    if (count != 0)
      raise "Build error\n"
    end
  end

  #def buildnboot
  #  Dir.chdir(@src_nfan + "/nboot")
  #  #cmd = "csc /nologo /debug:full /out:#@fan_bin/win/nboot.exe /fullpaths /recurse:*.cs /r:#@fan_lib/net/sys.dll"
  #  cmd = "csc /nologo /out:#@fan_bin/win/nboot.exe /fullpaths /recurse:*.cs /r:#@fan_lib/net/sys.dll"
  #  p = open("|" + cmd)
  #  count = 0
  #  while ((line = p.gets) != nil)
  #    print "  " + line
  #    count += 1
  #  end
  #  p.close
  #  if (count != 0)
  #    raise "Build error\n"
  #  end
  #end
  
  #def buildtools
  #  toolsDir = @src_nfan + "/tools"
  #  Dir.chdir(toolsDir)
  #  toolDirs = Dir.glob("*").delete_if { |f| File.ftype(f) != "directory" }
  #  toolDirs.each {|f| buildtool(toolsDir + "/" + f) }
  #end
  
  #def buildtool(dir)
  #  Dir.chdir(dir)
  #  toolName = dir.split("/").last
  #  
  #  #cmd = "csc /nologo /debug:full /out:#@fan_bin/" + toolName + ".exe /fullpaths"
  #  cmd = "csc /nologo /out:#@fan_bin/win/" + toolName + ".exe /fullpaths"
  #  cmd += " ..\\Tool.cs /recurse:*.cs /r:#@fan_lib/net/sys.dll"
  #  p = open("|" + cmd)
  #  count = 0
  #  while ((line = p.gets) != nil)
  #    print "  " + line
  #    count += 1
  #  end
  #  p.close
  #  if (count != 0)
  #    raise "Build error\n"
  #  end
  #end
end

# script
Maken.new.main