//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   15 Sep 05  Brian Frank  Creation
//   20 Aug 06  Brian Frank  Ported from Java to Fan
//

**
** FacetsAsm provides support for assembling the facets
** table for types and slots.
**
class FacetsAsm
{

//////////////////////////////////////////////////////////////////////////
// Construction
//////////////////////////////////////////////////////////////////////////

  new make(FPod fpod)
  {
    this.fpod = fpod;
    this.facets = FFacet[,]
  }

//////////////////////////////////////////////////////////////////////////
// Named Adds
//////////////////////////////////////////////////////////////////////////

  Void sourceFile(Str source)
  {
    if (source == null) return
    utf(FConst.SourceFile, FConst.Reflective, source)
  }

  Void lineNumber(Int line)
  {
    if (line == null || line == 0) return
    utf(FConst.LineNumber, FConst.Reflective, line.toStr)
  }

//////////////////////////////////////////////////////////////////////////
// Generic Adds
//////////////////////////////////////////////////////////////////////////

  Void utf(Str name, Int flags, Str data)
  {
    buf := Buf.make
    buf.writeUtf(data)
    add(name, flags, buf)
  }

  Void add(Str name, Int flags, Buf data)
  {
    f := FFacet.make
    f.name  = fpod.addName(name)
    f.flags = flags
    f.data  = data
    facets.add(f)
  }

//////////////////////////////////////////////////////////////////////////
// Fields
//////////////////////////////////////////////////////////////////////////

  FPod fpod
  FFacet[] facets

}