//
// Copyright (c) 2007, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   5 May 07  Brian Frank  Creation
//

using compiler
using fandoc

**
** CopyResources copies master resource files like fandoc.css
** to the target directory.
**
class CopyResources : DocCompilerSupport
{

  new make(DocCompiler compiler)
    : super(compiler)
  {
  }

  Void run()
  {
    copy(`/res/fandoc.css`, compiler.outDir)
  }

  Void copy(Uri uri, File dir)
  {
    from := type.pod.files[uri]
    to := dir + uri.name.toUri
    if (from == null)
    {
      log.warning("Missing resource file $uri")
      return
    }

    log.verbose("  Copy [$to]")

    to.create
    out := to.out
    from.in.pipe(out)
    out.close
  }

}
