//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   27 Mar 06  Brian Frank  Creation
//
package fan.sys;

/**
 * InStream interface.
 */
public interface InStream
{

  public int r();
  public int rChar();

  public Int read();

  public Int readBuf(Buf buf, Int n);

  public InStream unread(Int n);
  public InStream unread(int n);

  public Buf readAllBuf();
  public Buf readBufFully(Buf buf, Int n);

  public Int readU1();

  public Int readS1();

  public Int readU2();

  public Int readS2();

  public Int readU4();

  public Int readS4();

  public Int readS8();

  public Float readF4();

  public Float readF8();

  public Bool readBool();

  public Str readUtf();

  public Charset charset();
  public void charset(Charset charset);

  public Int readChar();

  public InStream unreadChar(Int c);

  public Str readLine();
  public Str readLine(Int max);

  public List readAllLines();

  public Str readAllStr();
  public Str readAllStr(Bool normalizeNewlines);

  public Map readProps();

  public Int pipe(OutStream out);
  public Int pipe(OutStream out, Int n);
  public Int pipe(OutStream out, Int n, Bool close);

  public Bool close();


}