//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   15 Sep 05  Brian Frank  Creation
//
package fanx.compiler;

import java.io.*;

/**
 * Location is a simple implementation of ILocation
 */
public class Location
  implements ILocation
{

//////////////////////////////////////////////////////////////////////////
// Construction
//////////////////////////////////////////////////////////////////////////

  public Location(Object file, int line, int col)
  {
    this.file = file;
    this.line = line;
    this.col  = col;
  }

  public Location(Object file)
  {
    this.file = file;
  }

  public Location()
  {
  }

//////////////////////////////////////////////////////////////////////////
// ILocation
//////////////////////////////////////////////////////////////////////////

  public Object file() { return file; }

  public int line() { return line; }

  public int col() { return col; }

  public static String format(ILocation loc) { return CompileException.format(loc); }

  public String format() { return CompileException.format(this); }

  public static String filename(ILocation loc)
  {
    String f = loc.file().toString();
    int s = f.lastIndexOf('/');
    if (s > 0) return f.substring(s+1);
    s = f.lastIndexOf('\\');
    if (s > 0) return f.substring(s+1);
    return f;
  }

//////////////////////////////////////////////////////////////////////////
// Fields
//////////////////////////////////////////////////////////////////////////

  public Object file;
  public int line;
  public int col;

}