//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   25 Dec 05  Brian Frank  Creation
//
package fanx.compiler;

import fan.sys.*;

/**
 * ShimPod is a place holder Pod we are currently compiling, but
 * haven't yet committed to the Sys namespace.
 */
public class ShimPod
  extends Pod
{

//////////////////////////////////////////////////////////////////////////
// Construction
//////////////////////////////////////////////////////////////////////////

  public ShimPod(String name)
  {
    super(name);
    this.existing = null;
  }

  public ShimPod(Pod existing)
  {
    super(existing.name().val);
    this.existing = existing;
  }

//////////////////////////////////////////////////////////////////////////
// Fields
//////////////////////////////////////////////////////////////////////////

  public final Pod existing;    // set if adding new types to an existing pod
  public boolean isScript;

}