//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   9 Mar 06  Brian Frank  Creation
//
package fanx.compiler.ast;

import fan.sys.*;
import fanx.compiler.*;

/**
 * SuperExpr is used to access super class slots.
 */
public class SuperExpr
  extends LocalVarExpr
{

//////////////////////////////////////////////////////////////////////////
// Construction
//////////////////////////////////////////////////////////////////////////

  public SuperExpr(ILocation location)
  {
    super(location);
  }

//////////////////////////////////////////////////////////////////////////
// Methods
//////////////////////////////////////////////////////////////////////////

  public int register()
  {
    return 0;
  }

  public int id()
  {
    return SUPER;
  }

  public String toString()
  {
    return "super";
  }

}