//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   3 Sep 05  Brian Frank  Creation
//
package fanx.compiler.steps;

import fanx.compiler.*;
import fanx.compiler.Compiler;
import fanx.compiler.asm.*;

/**
 * Assemble is responsible for assembling the resolved, normalized
 * abstract syntax tree into it's fcode representation which may
 * be then written out as a pod file or directly emitted as a Class.
 * This step delegates to fan.compiler.asm.Assembler.
 */
public class Assemble
  extends CompilerStep
{

  public Assemble(Compiler compiler)
  {
    super(compiler);
  }

  public void run()
  {
    compiler.fpod = new Assembler(compiler).assemblePod();
  }

}