//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   2 Dec 05  Brian Frank  Creation
//
package fanx.compiler.steps;

import java.io.*;
import java.util.*;
import fan.sys.*;
import fanx.compiler.*;
import fanx.compiler.Compiler;
import fanx.compiler.ast.*;

/**
 * InitShimTypes creates a ShimType for each ClassDef we are compiling.
 * This ShimType serves as a Type representation which hasn't yet been
 * committed to the Sys namespace.
 */
public class InitShimTypes
  extends CompilerStep
{

  public InitShimTypes(Compiler compiler)
  {
    super(compiler);
  }

  public void run()
  {
    for (int i=0; i<compiler.classDefs.length; ++i)
    {
      ClassDef def = compiler.classDefs[i];
      def.type = new ShimType(compiler.pod, def);
    }
  }

}