//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   25 Sep 05  Brian Frank  Creation
//
package fanx.test;

import java.io.*;
import fanx.compiler.*;
import fanx.compiler.Compiler;
import fanx.compiler.ast.*;
import fanx.compiler.parser.*;

/**
 * ImportTest
 */
public class ImportTest
  extends CompileTest
{

//////////////////////////////////////////////////////////////////////////
// Main
//////////////////////////////////////////////////////////////////////////

  public void doRun()
    throws Exception
  {
    verifyErr("using forgetIt\nclass Foo {}", "Pod not found: forgetIt", 1, 1);
    verifyErr("using sys\nclass Foo {}",  "Duplicate import: sys", 1, 1);
  }

//////////////////////////////////////////////////////////////////////////
// Utils
//////////////////////////////////////////////////////////////////////////

  public void verifyErr(String src, String msg, int line, int col)
    throws Exception
  {
    CompileException ex = null;
    try
    {
      compileToClass(src);
    }
    catch (CompileException e)
    {
      if (verbose)
      {
        println(e);
        println(msg + " [Test:" + line + ":" + col + "]");
      }
      ex = e;
    }
    verify(ex != null);
    verify(ex.msg.equals(msg));
    verify(ex.location.line() == line);
    verify(ex.location.col() == col);
  }

}