//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   16 Jan 07  Andy Frank  Creation
//

namespace Fan.Sys
{
  /// <summary>
  /// InStream interface.
  /// </summary>
  public interface InStream
  {

    int r();
    int rChar();

    Int read();

    Int readBuf(Buf buf, Int n);

    InStream unread(Int n);
    InStream unread(int n);

    Buf readAllBuf();
    Buf readBufFully(Buf buf, Int n);

    Int readU1();

    Int readS1();

    Int readU2();

    Int readS2();

    Int readU4();

    Int readS4();

    Int readS8();

    Float readF4();

    Float readF8();

    Bool readBool();

    Str readUtf();

    Charset charset();

    void charset(Charset charset);

    Int readChar();

    InStream unreadChar(Int c);

    Str readLine();
    Str readLine(Int max);

    List readAllLines();

    Str readAllStr();
    Str readAllStr(Bool normalizeNewlines);

    Map readProps();

    Int pipe(OutStream output);
    Int pipe(OutStream output, Int n);
    Int pipe(OutStream output, Int n, Bool close);

    Bool close();

  }
}