//
// Copyright (c) 2007, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   23 Feb 07  Andy Frank  Creation
//

namespace Fan.Sys
{
  /// <summary>
  /// Month.
  /// </summary>
  public sealed class Month : Enum
  {

    public static readonly Month jan = new Month(0,  "jan");
    public static readonly Month feb = new Month(1,  "feb");
    public static readonly Month mar = new Month(2,  "mar");
    public static readonly Month apr = new Month(3,  "apr");
    public static readonly Month may = new Month(4,  "may");
    public static readonly Month jun = new Month(5,  "jun");
    public static readonly Month jul = new Month(6,  "jul");
    public static readonly Month aug = new Month(7,  "aug");
    public static readonly Month sep = new Month(8,  "sep");
    public static readonly Month oct = new Month(9,  "oct");
    public static readonly Month nov = new Month(10, "nov");
    public static readonly Month dec = new Month(11, "dec");

    public static readonly List values;
    static Month()
    {
      List v = new List(Sys.MonthType, 12);
      v.add(jan).add(feb).add(mar).add(apr).add(may).add(jun)
       .add(jul).add(aug).add(sep).add(oct).add(nov).add(dec);
      values = v.ro();
    }

    private Month(int ordinal, string name)
    {
      Enum.make_(this, Int.m_pos[ordinal], Str.make(name).intern());
    }

    public override Type type() { return Sys.MonthType; }

  }
}