//
// Copyright (c) 2007, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   16 Jan 07  Andy Frank  Creation
//

namespace Fan.Sys
{
  /// <summary>
  /// OutStream interface.
  /// </summary>
  public interface OutStream
  {

    OutStream w(int b);

    OutStream write(Int x);

    OutStream writeBuf(Buf buf);
    OutStream writeBuf(Buf buf, Int n);

    OutStream writeI2(Int x);

    OutStream writeI4(Int x);

    OutStream writeI8(Int x);

    OutStream writeF4(Float x);

    OutStream writeF8(Float x);

    OutStream writeBool(Bool x);

    OutStream writeUtf(Str x);

    Charset charset();

    void charset(Charset charset);

    OutStream writeChar(Int c);

    OutStream writeChars(Str s);
    OutStream writeChars(Str s, Int off);
    OutStream writeChars(Str s, Int off, Int len);

    OutStream print(Obj s);

    OutStream printLine();
    OutStream printLine(Obj s);

    OutStream writeProps(Map props);
    OutStream writeProps(Map props, Bool close);

    void flush();

    Bool close();

  }
}