//
// Copyright (c) 2007, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   23 Feb 07  Andy Frank  Creation
//

namespace Fan.Sys
{
  /// <summary>
  /// Weekday.
  /// </summary>
  public sealed class Weekday : Enum
  {

    public static readonly Weekday sun = new Weekday(0, "sun");
    public static readonly Weekday mon = new Weekday(1, "mon");
    public static readonly Weekday tue = new Weekday(2, "tue");
    public static readonly Weekday wed = new Weekday(3, "wed");
    public static readonly Weekday thu = new Weekday(4, "thu");
    public static readonly Weekday fri = new Weekday(5, "fri");
    public static readonly Weekday sat = new Weekday(6, "sat");

    public static readonly List values;
    static Weekday()
    {
      List v = new List(Sys.WeekdayType, 7);
      v.add(sun).add(mon).add(tue).add(wed).add(thu).add(fri).add(sat);
      values = v.ro();
    }

    private Weekday(int ordinal, string name)
    {
      Enum.make_(this, Int.m_pos[ordinal], Str.make(name).intern());
    }

    public override Type type() { return Sys.WeekdayType; }

  }
}