//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   31 Jan 07  Andy Frank  Creation
//

using Fan.Sys;
using Fanx.Fcode;

namespace Fanx.Emit
{
  /// <summary>
  /// FMixinBodyEmit emits the class body of a mixin type.
  /// </summary>
  public class FMixinBodyEmit : FClassEmit
  {

  //////////////////////////////////////////////////////////////////////////
  // Constructor
  //////////////////////////////////////////////////////////////////////////

    public FMixinBodyEmit(Emitter emitter, Type parent, FType type)
      : base(emitter, parent, type)
    {
    }

  //////////////////////////////////////////////////////////////////////////
  // Overrides
  //////////////////////////////////////////////////////////////////////////

    public override void emit()
    {
      init(nname(type.m_self)+"_", @base(), mixins(), FConst.Public | FConst.Final);
      this.selfName = className;
      //preview();
      emitType();

      // emit class body
      for (int i=0; i<type.m_fields.Length;  i++) emit(type.m_fields[i]);
      for (int i=0; i<type.m_methods.Length; i++) emit(type.m_methods[i]);
      emitTypeConstFields();
    }

    protected override string @base()
    {
      return "System.Object";
    }

    //protected void emit(FField f)
    //{
    //  if ((f.flags & FConst.Static) != 0)
    //    super.emit(f);
    //}

    protected override void emitType()
    {
      base.emitType();

      // TODO
      PERWAPI.CILInstructions code = ctor.CreateCodeBuffer();
      code.Inst(PERWAPI.Op.ret);
      code = cctor.CreateCodeBuffer();
      code.Inst(PERWAPI.Op.ret);
    }

    protected override void emit(FMethod m)
    {
      // TODO
      //string name = Name(m.name);
      //if (name == "static$init") { EmitStaticInit(m); return; }

      new FMethodEmit(this, m).emitMixinBody();
    }

  //////////////////////////////////////////////////////////////////////////
  // Fields
  //////////////////////////////////////////////////////////////////////////

  }
}