//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   27 Sep 06  Andy Frank  Creation
//

using System;

namespace Fanx.Fcode
{
  /// <summary>
  /// FFacet is meta-data for a FType of FSlot.
  /// </summary>
  public class FFacet
  {
    public FFacet(int name, int flags, FBuf data)
    {
      this.m_name  = name;
      this.m_flags = flags;
      this.m_data  = data;
    }

    public FFacet()
    {
    }

    public static FFacet facet(FPod pod, FFacet[] facets, string name)
    {
      if (facets != null)
      {
        for (int i=0; i<facets.Length; i++)
          if (pod.name(facets[i].m_name) == name)
            return facets[i];
      }
      return null;
    }

    public FFacet read(FStore.Input input)
    {
      m_name = input.u2();
      m_flags = input.u1();
      m_data = FBuf.read(input);
      return this;
    }

    public static FFacet[] none = new FFacet[0];

    public int m_name;    // name index
    public int m_flags;
    public FBuf m_data;
  }
}