//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   27 Sep 06  Andy Frank  Creation
//

using System;

namespace Fanx.Fcode
{
  /// <summary>
  /// FMethodVar models one parameter or local variable in a FMethod.
  /// </summary>
  public class FMethodVar
  {

  //////////////////////////////////////////////////////////////////////////
  // Flags
  //////////////////////////////////////////////////////////////////////////

    public bool IsParam() { return (flags & FConst.Param) != 0; }

  //////////////////////////////////////////////////////////////////////////
  // IO
  //////////////////////////////////////////////////////////////////////////

    public FMethodVar read(FStore.Input input)
    {
      name  = input.u2();
      type  = input.u2();
      flags = input.u1();
      def   = FBuf.read(input);
      return this;
    }

  //////////////////////////////////////////////////////////////////////////
  // Fields
  //////////////////////////////////////////////////////////////////////////

    public int name;      // str index
    public int type;      // type qname index
    public int flags;     // method variable flags
    public FBuf def;      // default expression or null (only for params)

  }
}