//
// Copyright (c) 2006, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   27 Sep 06  Andy Frank  Creation
//

using System;

namespace Fanx.Fcode
{
  /// <summary>
  /// FSlot is the read/write fcode representation of sys::Slot.
  /// </summary>
  public class FSlot
  {
    public FFacet facet(FPod pod, string name)
    {
      return FFacet.facet(pod, m_facets, name);
    }

    protected void readCommon(FStore.Input input)
    {
      m_name  = input.u2();
      m_flags = input.u4();
    }

    protected void readFacets(FStore.Input input)
    {
      int len = input.u2();
      if (len == 0)
      {
        m_facets = FFacet.none;
      }
      else
      {
        m_facets = new FFacet[len];
        for (int i=0; i<len; i++)
          m_facets[i] = new FFacet().read(input);
      }
    }

    public int m_name;          // str index
    public int m_flags;         // bitmask
    public FFacet[] m_facets;   // meta-data
  }
}