//
// Copyright (c) 2007, Brian Frank and Andy Frank
// Licensed under the Academic Free License version 3.0
//
// History:
//   3 Jan 07  Brian Frank  Creation
//

**
** SlotTest
**
class SlotTest : Test
{

//////////////////////////////////////////////////////////////////////////
// Find
//////////////////////////////////////////////////////////////////////////

  Void testFind()
  {
    verifySame(Slot.find("sys::Int.plus"), Int.type.method("plus"))
    verifySame(Slot.findMethod("sys::Int.plus"), Int.type.method("plus"))
    verifySame(Pod.find("sys::Int.foo", false), null)
    verifyErr(UnknownPodErr.type) |,| { Slot.find("badPodName::Foo.bar") }
    verifyErr(UnknownTypeErr.type) |,| { Slot.find("sys::Foo.bar") }
    verifyErr(UnknownSlotErr.type) |,| { Slot.find("sys::Int.foo") }
    verifyErr(CastErr.type) |,| { Slot.findField("sys::Int.isSpace") }
  }

}